package de.techbits.gwt.examples.starrating.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

import de.techbits.gwt.widgets.client.RatingService;
import de.techbits.gwt.widgets.client.RatingServiceAsync;
import de.techbits.gwt.widgets.client.StarRating;

/**
 * Example for the StarRating widget.
 * 
 * @see de.techbits.gwt.widgets.client.StarRating
 * @author Florian Maul (f.maul@sourceforge.net)
 */
public class StarRatingExample implements EntryPoint {

    /**
     * This is the entry point method.
     */
    public final void onModuleLoad() {
        // Create the client proxy
        RatingServiceAsync ratingService = (RatingServiceAsync) GWT.create(RatingService.class);

        // URL at which our example service implementation is running.
        ServiceDefTarget endpoint = (ServiceDefTarget) ratingService;
        String moduleRelativeURL = GWT.getModuleBaseURL() + "/ratingservice";
        endpoint.setServiceEntryPoint(moduleRelativeURL);

        // Display some example ratings...
        HorizontalPanel hp = new HorizontalPanel();

        VerticalPanel vp1 = new VerticalPanel();
        vp1.add(new Label("client-side only:"));
        vp1.add(new HTML("<code>StarRating sr = new StarRating(6);<br>sr.setStars(2);</code>"));
        StarRating sr = new StarRating(6);
        sr.setRating(2);
        vp1.add(sr);
        hp.add(vp1);

        VerticalPanel vp2 = new VerticalPanel();
        vp2.add(new Label("rating data provided by a servlet:"));
        vp2.add(new HTML("<code>StarRating sr2 = new StarRating(10, new Integer(2), \"\", ratingService,"
                + " false);<br>hp2.add(sr2);</code>"));
        vp2.add(new HTML("An Integer with a custom id (2) and a custom string (\"\") can be"+
                " used to pass the reference of the rated object to the service."));
        StarRating sr2 = new StarRating(10, new Integer(2), "", ratingService, false);
        
        vp2.add(sr2);
        hp.add(vp2);

        RootPanel.get("content").add(hp);

    }

}
